;*************************************************************
;  18.06.10   AD9835,    , 
; LCD 220
;*************************************************************


.include "m8def.inc"
.def data = r0
.def worktx_l = r1
.def worktx_m = r2
.def worktx_h = r3
.def loop = r4
.def flag_reg = r5
.def number = r6
.def ind_l = r7
.def ind_m = r8
.def ind_h = r9
.def fl_l = r10
.def fl_m = r11
.def fl_h = r12
.def fm_l = r13
.def fm_m = r14
.def fm_h = r15

.def work_l =r16
.def work_m =r17
.def work_h =r18  
.def temp =r19
.def temp1 =r20 
.def valc = r21
.def mult_l =r22 
.def mult_m = r23
.def mult_h = r24
.def mult_hh = r25
.def pered_l = r26
.def pered_m = r27
.def pered_h = r28
.def temp16_l = r29
.def temp16_m = r30
.def temp16_h = r31






;PORT B
.equ RS = 0
.equ DB4 = 1
.equ DB5 = 2
.equ DB6 = 3
.equ DB7 = 4
.equ TX = 5;
.equ UP = 6; 
.equ DN = 7 ;


;PORT C

.equ BND1 = 1;
.equ BND2 = 2;
.equ BND3 = 3;
.equ SCLK = 4
.equ SDAT= 5


;PORT D
.equ FSYN = 0
.equ RIT = 1
.equ MKHZ = 2
.equ SAV = 3
.equ BND = 4
.equ ATT = 5
.equ EE = 6
.equ RW = 7

;equ stack = 0x66



.equ trig = 0
.equ flag_sp = 0
.equ dacplus = 1
.equ regcng =2

 
.org 0
reset:
  ;  

  ldi temp,LOW (ramend)
  out SPL,temp
  ldi temp,HIGH (ramend)
  out SPH,temp

; 

	ldi temp, 0b00011111
	out DDRB, temp
	ldi temp, 0b11100000
	out PORTB, temp

	ldi temp, 0b00111110
	out DDRC, temp
	ldi temp, 0b11000000
	out PORTC, temp

	ldi temp, 0b11100001;
	out DDRD, temp
	ldi temp, 0b00011111		
	out PORTD, temp




       

	

 
      	

;*******************************************************
;****** *************************
;*******************************************************
	ldi temp, 0x20 ; 
	rcall pause_ro

	ldi temp, 0x20	;  4-  
	mov data, temp
	rcall lcdout	
 	ldi temp, 0x02 ; 
	rcall pause_ro	; 	
  
        ldi      temp,0x28              ;4- , 2 , 57
 		mov data, temp
        rcall    lcdout
        rcall    lcdout

		ldi      temp,0x0C              
 		mov data, temp
        rcall    lcdout
		rcall    lcdout

        ldi      temp,0x06             ;   
		mov data, temp
        rcall    lcdout           
        rcall    lcdout
		
		rcall cgram_smb	;  ""	
		
;**************************************************************
;******** ***********************************
;**************************************************************        
         
hotstart:ldi valc, 0x01 
		;ldi temp,0x01
		;mov number, temp
		 clr number ;   - 160
       	clr flag_reg 
		
		rcall kHz
		rcall ind_rx
		
		rcall dds_init



   ;************************** 
   ;        
   ;**************************

 

loadbnd:ldi temp, fmin  ; 
		add temp, number
		adc temp, number
		adc temp, number	
 		rcall EERead
 		mov fl_h, temp

 		ldi temp, fmin + 1
		add temp, number
		adc temp, number
		adc temp, number
 		rcall EERead
 		mov fl_m, temp

		ldi temp, fmin + 2
		add temp, number
		adc temp, number
		adc temp, number
 		rcall EERead
 		mov fl_l, temp

 		ldi temp, fmax	;  
		add temp, number
		adc temp, number
		adc temp, number
 		rcall EERead
 		mov fm_h, temp

 		ldi temp, fmax + 1
		add temp, number
		adc temp, number
		adc temp, number
 		rcall EERead
 		mov fm_m, temp

		ldi temp, fmax + 2
		add temp, number
		adc temp, number
		adc temp, number
 		rcall EERead
 		mov fm_l, temp

 
	       
         ldi temp,ch  ;     
         add temp, number
		adc temp, number
		adc temp, number
		 rcall EERead
         mov work_h, temp
         mov worktx_h, work_h
         ldi temp, ch +1
		add temp, number
		adc temp, number
		adc temp, number
         rcall EERead
		mov work_m, temp
         mov worktx_m, work_m
         
		 ldi temp, ch +2
		add temp, number
		adc temp, number
		adc temp, number
         rcall EERead 
         mov work_l, temp
         mov worktx_l, work_l
;***************************************************
;     
;***************************************************
		sbi PORTD, FSYN
		mov temp, number ;160
		cpi temp, 0x00
		brne onebnd
		ldi temp, 0b00111110
		out DDRC, temp
		ldi temp, 0b11000010
		out PORTC, temp
		rjmp initial

onebnd: cpi temp, 0x01		;80
		brne twobnd
		ldi temp, 0b00111110
		out DDRC, temp
		ldi temp, 0b11000100
		out PORTC, temp	
		rjmp initial

twobnd: 					;40
		
		ldi temp, 0b00111110
		out DDRC, temp
		ldi temp, 0b11001000
		out PORTC, temp
		
initial:
		rcall display
 		rcall syntez


;***************************************         
 ;*** **********************
 ;*************************************
 bigloop:rcall smetr
	sbis PIND, RIT ;
	rjmp rit_rout; 

	sbis PINB, TX
	rjmp tx_rout

	sbis PIND, BND ; BND?	
	rjmp nxtbnd;  
	

  no_rit:sbrc valc, trig
        rjmp pl_min
	
		sbic PINB,UP
        rjmp bigloop 
         
       sbic PINB,DN
       rjmp bigloop
         
	sbr valc, 0b00000001
	rjmp bigloop

     
         
 
 
  ;***   ************************
 pl_min: sbic PINB,UP
 	rjmp tstpl
 	sbic PINB,DN
 	rjmp tstmin
 	rjmp bigloop
 	
 tstpl:rcall add_one
 	cbr valc,0b00000001
 	rjmp initial
 tstmin:rcall sub_one
 	cbr valc, 0b00000001
 	rjmp initial	

 
;**************** *********************
 
  add_one:
	 
	 
	 sbic PIND,MKHZ
	 rjmp nxtstp1
 	ldi temp, 0x64
	rjmp onepl
nxtstp1:sbic PIND, SAV
	rjmp nxtstp2
	ldi temp, 0x01
	rjmp onepl
nxtstp2:ldi temp, 0x05 
 
onepl:	 clc
	add work_l, temp    ;   1    	
	 clr temp
	 adc work_m, temp ;   ,   
	 adc work_h, temp
	 cp fm_h, work_h	;   .   
	 brne end_add		;   ?
	 cp fm_m, work_m	;   .   
	 brne end_add		;   ?
	 cp  fm_l, work_l	;     . , 
	 brsh end_add
	 mov work_h, fl_h	;    -  . 
	 mov work_m, fl_m
	 mov work_l, fl_l	; 
 end_add:sbrc flag_reg, flag_sp
 	ret 
 	mov worktx_h, work_h;  
	mov worktx_m, work_m
 	mov worktx_l, work_l	 	 
 out_add:ret 
 
 
 ;************ *****************************
  	 
 sub_one: sbic PIND,MKHZ
	 rjmp nxtstp3
 	ldi temp, 0x64
	rjmp onemin
nxtstp3:sbic PIND, SAV
	rjmp nxtstp4
	ldi temp, 0x01
	rjmp onemin
nxtstp4:ldi temp, 0x05 
	

	
onemin:	clc
	sub work_l, temp	;  1 . 
	clr temp
	sbc work_m, temp
	sbc work_h, temp ;    -   
	cp work_h, fl_h	 ;     . 
	brne end_sub	; ?
	cp fl_m, work_m
	brne end_sub
	cp fl_l, work_l	;    
	brlt end_sub	;     , 
	mov work_h, fm_h	;
	mov work_m, fm_m
	mov work_l, fm_l	; 
end_sub:sbrc flag_reg, flag_sp
	ret
	mov worktx_h, work_h
	mov worktx_m, work_m
 	mov worktx_l, work_l
out_sub:ret


;**********************************************
;**************************************
;**********************************************

tx_rout:mov pered_l, work_l	;   
	mov pered_m, work_m
	mov pered_h, work_h	; 
	mov work_l, worktx_l	;  
	mov work_m, worktx_m
	mov work_h, worktx_h
	
	rcall ind_tx

	rcall display
	rcall syntez

tx_ret:sbic PINB, TX		;   
	
	rjmp end_tx		; 
	rjmp tx_ret		;  
	
end_tx:	mov worktx_l, work_l	;   
	mov worktx_m, work_m
	mov worktx_h, work_h 	;
	mov work_l, pered_l	;  
	mov work_m, pered_m
	mov work_h, pered_h
	sbrs flag_reg, flag_sp	;    ?
	rjmp del_num
	rcall rit_ind
	rjmp initial
del_num:rcall ind_rx
	rjmp initial

;***********************************************	
;*************************************
;***********************************************	
rit_rout: ldi temp, 0x02	;   
         rcall pause_ro
		sbis PIND, RIT		;  
		rjmp rit_rout

		mov temp, flag_reg
		sbrc temp, flag_sp	;   , 
		rjmp res_rit		;
		sbr temp,0x01	;  , 
		mov flag_reg, temp
		rcall rit_ind
		rjmp initial
res_rit:mov temp, flag_reg
		cbr temp, 0x01 		; 
		mov flag_reg, temp
		rcall ind_rx		
		mov work_h, worktx_h
		mov work_m, worktx_m
		mov work_l, worktx_l
		rjmp initial

;**********************************
; 
;**********************************
nxtbnd: sbis PIND, SAV
		rjmp savestart
		ldi temp, 0x02	;   
    	rcall pause_ro
		sbis PIND, BND		; 
		rjmp nxtbnd
 		inc number
		mov temp, number
		cpi temp, 0x03
		brne endbnd
		clr number
	endbnd:	rjmp loadbnd 
	
;********************************************** 	 			  	    
;******       ******************
;*********************************************
 
 
display:;ret
	 
;************    **************
	mov mult_l, work_l
	mov mult_m, work_m
	mov mult_h, work_h
	ldi temp16_l, 0xA0 ;   
	ldi temp16_m, 0x86
	ldi temp16_h, 0x01
	rcall decdig
	mov ind_h, temp
	swap ind_h
	ldi temp16_l, 0x10 ;   
	ldi temp16_m, 0x27
	clr temp16_h
	rcall decdig
	add ind_h, temp
	ldi temp16_l, 0xE8 ;  
	ldi temp16_m, 0x03
	clr temp16_h
	rcall decdig
	mov ind_m, temp
	swap ind_m	
	ldi temp16_l, 0x64 ;  
	clr temp16_m
	clr temp16_h
	rcall decdig
	
	
	add ind_m, temp
	ldi temp16_l, 0x0A	;   
	clr temp16_m
	clr temp16_h
	rcall decdig
	
	mov ind_l, temp ; 
	swap ind_l	;
	
enddig:add ind_l, mult_l

 
  ;********************  *************************
  		ldi      temp,0x85 ;  4  
 		mov data, temp
        rcall    lcdout
        rcall    lcdout

	sbi PORTB, RS ;  
	rcall long

	mov temp, ind_h  ;1-?
	cbr temp, 0x0F
	swap temp
	subi temp, -0x30
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x2E; 2-
	mov data, temp
	rcall lcdout
	rcall lcdout

	mov temp, ind_h  ;3-?
	cbr temp, 0xF0
	subi temp, -0x30
	mov data, temp	
	rcall lcdout
	rcall lcdout



	mov temp, ind_m ;4-?
	cbr temp, 0x0F
	swap temp
	subi temp, -0x30
	mov data, temp		
	rcall lcdout
	rcall lcdout
	


	mov temp, ind_m ;5-?
	cbr temp, 0xF0
	subi temp, -0x30
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x2E; 6-
	mov data, temp
	rcall lcdout
	rcall lcdout

	mov temp, ind_l ;7-?
	cbr temp, 0x0F
	swap temp
	subi temp, -0x30
	mov data, temp
	rcall lcdout
	rcall lcdout


	mov temp, ind_l;8-?
	cbr temp, 0xF0
	subi temp, -0x30
	mov data, temp	
	rcall lcdout
	rcall lcdout


	ldi temp, 0x30; 9
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	 rcall long	
	


	 
  	ret

;************************************************
 ;*******   ************
 ;************************************************
 
 
 
 
 syntez: 
 	clr temp1

	ldi temp16_l,0x50   ; 
 	ldi temp16_m, 0xC3
	 clr temp16_h
	 
	 add temp16_l, work_l	;  _16 
	 adc temp16_m, work_m
	 adc temp16_h, work_h
	 
 	ldi temp, 0x5B   ;   2^32/50,000,00
	mov ind_l, temp	
	ldi temp, 0x03
	mov ind_m, temp
	clr ind_h
	ldi temp, 16
	mov loop, temp

	clr mult_l ;  mult -  
	clr mult_m
	clr mult_h
	clr mult_hh
	rjmp multic


nxtmult:add mult_l, temp16_l
		adc mult_m, temp16_m
		adc mult_h, temp16_h
		adc mult_hh, temp1
noadd:	clc
		rol temp16_l
		rol temp16_m
		rol temp16_h
		rol temp1

		dec loop
		brne multic
		rjmp endmult ;   -  

multic:	lsr ind_h
		ror ind_m
		ror ind_l

		brcc noadd
		rjmp nxtmult

endmult:	
		mov temp, number ;160
		cpi temp, 0x00
		brne onebnda
		subi mult_l,0xE0  ;      
		sbci mult_m, 0x05;    160= (50 )
		sbci mult_h, 0x00
		sbci mult_hh,0x00
		rjmp tosynt

onebnda: cpi temp, 0x01		;80
		brne twobnda
		subi mult_l,0x38  ;      
		sbci mult_m, 0x0A;    80= (38 )
		sbci mult_h, 0x00; 
		sbci mult_hh,0x00
	
		rjmp tosynt

twobnda: 					;40
		subi mult_l,0x2A  ;      
		sbci mult_m, 0x13;    40= (132 )
		sbci mult_h, 0x00; 
		sbci mult_hh,0x00
	

tosynt:	mov temp, flag_reg ;    
		sbrs temp,regcng
        rjmp    load_reg1
		cbr temp, regcng
		mov flag_reg, temp
		 
	ldi	temp16_h,0x30      ;  -  8      L LSB	 8   H LSB   0
	mov	temp16_l,mult_l	;  8  .
	rcall	send_dds	;   AD9835
	ldi	temp16_h,0x21	;  -   8      L MSB	
        mov	temp16_l,mult_m     	;  8  .
	rcall	send_dds	;   AD9835
	ldi	temp16_h,0x32	;  -  8      L SB	 8   H SB   0
	mov	temp16_l,mult_h  	;  8  .
	rcall	send_dds	;   AD9835
	ldi     temp16_h,0x23
	mov	temp16_l,mult_hh 	;  8  .
	rcall	send_dds
	ldi     temp16_h,0x50
	rcall	send_dds	

load_reg1:
	sbr temp, regcng
	mov flag_reg, temp	
 	ldi	temp16_h,0x34      ;  -  8      L LSB	 8   H LSB   0
	mov	temp16_l,mult_l	;  8  .
	rcall	send_dds	;   AD9835
	ldi	temp16_h,0x25	;  -   8      L MSB	
        mov	temp16_l,mult_m     	;  8  .
	rcall	send_dds	;   AD9835
	ldi	temp16_h,0x36	;  -  8      L SB	 8   H SB   0
	mov	temp16_l,mult_h  	;  8  .
	rcall	send_dds	;   AD9835
	ldi     temp16_h,0x27
	mov	temp16_l,mult_hh 	;  8  .
	rcall	send_dds
	ldi     temp16_h,0x58
	rcall	send_dds
		
	ret




  ;*********************
  ;        
  ;*********************	  
  pause_ro:;ret ; 1  - 8x7 
  	 ser temp1
  retu1:ser mult_hh
  mov loop, mult_hh
  	
  retu2:dec loop
  	brne retu2
  	dec temp1
  	brne retu1
  	dec temp
  	brne pause_ro
  	ret
 
  	
  long:	;ret
   	
  	ldi temp1, 0x80 
  retlong:dec temp1
  	brne retlong
  	ret
 
 ;***   ***
 lcdout:;ret 

 	sbi PORTD,EE
 	rol data
 	brcs h_lev0
 	cbi PORTB,DB7
 	rjmp nxt_a
 h_lev0:sbi PORTB,DB7
 nxt_a:	rol data
 	brcs h_lev1
 	cbi PORTB,DB6
 	rjmp nxt_b
 h_lev1:sbi PORTB,DB6
  nxt_b:rol data
 	brcs h_lev2
 	cbi PORTB,DB5
 	rjmp nxt_c
 h_lev2:sbi PORTB,DB5
 nxt_c: rol data
 	brcs h_lev3
 	cbi PORTB,DB4
 	rjmp nxt_d
 h_lev3:sbi PORTB,DB4
  
 nxt_d:rcall long
	cbi PORTD,EE
 	rcall long 
 	ret

;*****************************
;***** S-***********
;*****************************
  
smetr: 
		ldi temp, 0b00100000 ;
		out ADMUX, temp
		ldi temp, 0b11000111
		out ADCSRA, temp

endmeg:	sbic ADCSRA, ADSC
		rjmp endmeg
		in  loop,ADCH ;    
		swap loop
		mov temp, loop
		andi temp, 0x0F;     0.6 
		mov loop, temp

		


		ldi temp, 0xC0 ;  -    
		mov data, temp
		rcall lcdout
		rcall lcdout
		rcall long
		rcall long
		rcall long
		rcall long

		clr mult_h
		sbi PORTB,RS

quadro:	ldi temp, 0x01
		mov data, temp ;  ""
		rcall lcdout
		rcall lcdout

pusto:	
		ldi temp, 0x01	
		add mult_h, temp; .  1

		brhs end_adc ;   16,  
		
		cp loop, mult_h ;   		
		brcc quadro 
		 
		ldi temp, 0x20 ;  
		mov data, temp 
		rcall lcdout
		rcall lcdout
		rjmp pusto

end_adc:cbi PORTB, RS
		
  		ret
;**************************************************
;*****  ***********************
;**************************************************
savestart: ldi temp, 0x02	;
    	rcall pause_ro
		sbis PIND, SAV		;  
		rjmp savestart
		clr temp
		clr temp16_h
		ldi temp16_l, ch
		add temp16_l, number
		adc temp16_l, number
		adc temp16_l, number
		adc temp16_h, temp
		mov temp, work_h
		rcall EEWrite

		clr temp
		clr temp16_h
		ldi temp16_l, ch+1
		add temp16_l, number
		adc temp16_l, number
		adc temp16_l, number
		adc temp16_h, temp
		mov temp, work_m
		rcall EEWrite

		clr temp
		clr temp16_h
		ldi temp16_l, ch+2
		add temp16_l, number
		adc temp16_l, number
		adc temp16_l, number
		adc temp16_h, temp
		mov temp, work_l
		rcall EEWrite
		rcall outsym
		rjmp initial
 	




;**********************************************
; HEX-  	
 ;********************************************** 	
 decdig:ldi temp,-1
 minus:sub mult_l, temp16_l
 	sbc mult_m, temp16_m
 	sbc mult_h, temp16_h
 	inc temp
 	brsh minus
 	add mult_l, temp16_l
	adc mult_m, temp16_m
 	adc mult_h, temp16_h
 	ret

 ;*************************
 ;        
 ;**************************       
  EEwrite: sbic EECR, EEWE
  	rjmp EEwrite
  	out EEARL, temp16_l
	out EEARH, temp16_h
  	out EEDR, temp
  	sbi EECR, EEMWE
	sbi EECR, EEWE
  	ret      
 ;***********************
 ;          
 ;***********************
  EEread: sbic EECR,EEWE
  	  rjmp EERead
  	  out EEARL,temp
	  out EEARH, temp1
  	  sbi EECR,EERE
  	  in temp,EEDR
  	  ret 
	  
	  

;****************************************************************************
;	 16-bit  (temp16_h:temp16_l)  DDS 
;****************************************************************************

send_dds:
	ldi 	temp,16		
	cbi	PORTD,FSYN	;  PD0 in PORTD -  	         
send_1:	cbi	PORTC,SDAT   	;     PC5 in PORTC        
        sbrc temp16_h,7		; Check MSBit of 16-bit word
	sbi	PORTC,SDAT  	;   1
      	sbi	PORTC,SCLK	; 
	cbi	PORTC,SCLK      ;     
	rol	temp16_l   	;  
	rol	temp16_h
	dec	temp
	brne	send_1	
	sbi	PORTD,FSYN	;  - 
	ret

 
;*********************************************************
;******** RX
;*********************************************************

ind_rx:

	ldi temp, 0x80 ;   
	mov data, temp
	rcall lcdout
	rcall lcdout
	
	rcall long
	rcall long
	rcall long
	rcall long

	sbi PORTB, RS
	rcall long

	ldi temp, 0x52 ;1
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x78 ;2
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20 ;3
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	rcall long

	ret
;******************************
;******* **************
;******************************
kHz:
	
	ldi temp, 0x91 ;   
	mov data, temp
	rcall lcdout
	rcall lcdout
	
	rcall long
	rcall long
	rcall long
	rcall long

	sbi PORTB, RS
	rcall long

	ldi temp, 0x6B ;1
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x48 ;2
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x7A ;3
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	rcall long
	
	ret

;*********************************************************
;******** TX
;*********************************************************

ind_tx:
	
	ldi temp, 0x80 ;   
	mov data, temp
	rcall lcdout
	rcall lcdout
	
	rcall long
	rcall long
	rcall long
	rcall long

	sbi PORTB, RS
	rcall long

	ldi temp, 0x54 ;"T"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x78 ;"x"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20 ;3
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	rcall long
	
	ret

;*********************************************************
;******** Rit
;*********************************************************

rit_ind:
	
	ldi temp, 0x80 ;   
	mov data, temp
	rcall lcdout
	rcall lcdout
	
	rcall long
	rcall long
	rcall long
	rcall long

	sbi PORTB, RS
	rcall long

	ldi temp, 0x52 ;"R"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x69 ;"i"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x74 ;"t"
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	rcall long
	
	ret

 ;********************   "Saved"*************************
  outsym:
  		
  		ldi      temp,0x83 ;  4  
 		mov data, temp
        rcall    lcdout
        rcall    lcdout

	SBI PORTB, RS ;  
	rcall long

	ldi temp, 0x20 ;1
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20 ;2
	mov data, temp		
	rcall lcdout
	rcall lcdout
	
	ldi temp, 0x53; "S"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x61 ;"a"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x76 ;"v"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x65;"e"
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x64; "d"
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20  ;8
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20 ;9
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20; 10
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x20; 11
	mov data, temp
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	 rcall long	
	

		ldi temp, 0x30	;
    	rcall pause_ro	 
  	ret
;************************************************************************************************
dds_init:       
	clr     temp16_l           ; Clears a register temp0
	ldi	temp16_h,0xF8	; (LSByte sent from temp0 is unimportant) SLEEP = RESET = CLR = 1
	rcall	send_dds			
	ldi	temp16_h,0xB0	; (LSByte sent from temp0 is unimportant); SYNC = SELSRC = 1
	rcall	send_dds			
	ldi	temp16_h,0xC0	; (LSByte sent from temp0 is unimportant); SLEEP = RESET = 0
	rcall	send_dds
        ret  
;******************************************************************************
;*************   CGRAM*******************************************
;******************************************************************************
	
cgram_smb:ldi temp,0x48 ;    
 		mov data, temp
        rcall    lcdout
        rcall    lcdout

	SBI PORTB, RS ;  
	rcall long

	ldi temp, 0x1B ;1
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B ;2
	mov data, temp		
	rcall lcdout
	rcall lcdout
	
	ldi temp, 0x1B; 3
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B ;4
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B ;5
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B;6
	mov data, temp	
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B; 7
	mov data, temp
	rcall lcdout
	rcall lcdout

	ldi temp, 0x1B  ;8
	mov data, temp	
	rcall lcdout
	rcall lcdout

	cbi PORTB, RS
	 rcall long	
	

	ldi temp, 0x30	;
    rcall pause_ro	 
  	ret
.eseg
.org 0
;  
	fmin:
	.db 0x02, 0xC3, 0x08; 1.810.00 kHz
	fmin1: 
	.db 0x05, 0x57, 0x30; 3.500.00 kHz
	fmin2:
	.db 0x0A, 0xAE, 0x60; 7.000.00 kHz
	
; 
	fmax:
	.db 0x03, 0x0D, 0x40; 2.000.00 kHz
	fmax1:
	.db 0x05, 0xCC, 0x60; 3.800.00 kHz
	fmax2:
	.db 0x0B, 0x23, 0x90; 7.300.00 kHz
	
  
   ch:
  .db 0x02, 0xE6, 0x30 ; -   - 1.900.00 
  ch1:
  .db 0x05, 0x7E, 0x40; 3.600.00 kHz
  ch2:
  .db 0x0A, 0xBE, 0x00; 7.040.00 kHz
  

  
  .db "(c)Temerev_18_06_2010"
